
; ᠫ   - ଠ AOH.  1.2
; Copyright  Vladislav Ivanov 2:5069/16@fidonet. Astrakhan, Russia, 1999.

; ஢: tasm  disaon.asm /w2 /m9
;                tlink disaon.obj

          IDEAL
          model small, pascal
          locals @@

          ; ⠭    ⨧樨 SB
          Sb11kgz       = 166
          Sb22kgz       = 211
          Sb44kgz       = 234

          ; ⠭  .   ⮢ SB
          ; DMA  ⠪  ࠢ DSP
          MixerAddr     = 04h
          MixerData     = 05h
          SWriteData    = 0Ch
          SReadData     = 0Ah
          SReset        = 06h
          SWriteStatus  = 0Ch
          SDataAvail    = 0Eh
          SbDMAWrite    = 14h
          SbIntRequest  = 0F2h
          SbProInit     = 48h
          SbProStart    = 91h
          SbHalt        = 0D0h
          SbContinue    = 0D4h
          DMAStartAddr  = 02h
          DMAStartLoop  = 03h
          DMACmd        = 08h
          DMAStatus     = 08h
          DMARequest    = 09h
          DMAMask       = 0Ah
          DMAMode       = 0Bh
          DMAPage       = 83h
          DMAFlipReset  = 0Ch
          SbON          = 0D1h
          SbOFF         = 0D3h
          SbTime        = 40h

          ; ⠭ ࠢ ஬
          MReset        = 0
          MMaster       = 22h
          MVoice        = 04h
          MLine         = 2Eh
          MMidi         = 26h
          MCD           = 28h

          ; ᮮ饭  訡 ணࠬ
          seMemory  =  1   ; 筮 
          seFpu     =  2   ;   室騩 ᮯ
          seCmd     =  3   ; ୮  
          seOpt     =  4   ; ୮  
          seArg0    =  5   ;   㬥
          seArg1    =  6   ;   ᫨誮  
          seArg2    =  7   ; ⨬ ᨬ  
          seArg3    =  8   ; ९ 
          seArg4    =  9   ; 訡 ࠬ஢ ᨣ
          seSb      =  10  ;  㦥 㪮   訡
          seHelp    =  11  ; 뢥 ࠢ  ணࠬ
          seBreak   = 255  ;  Ctrl-Break

          CODESEG

start:    mov    ax, @data
          mov    ds, ax
          ; । 
          mov    bx, sp
          add    bx, 0Fh
          mov    cl, 4
          shr    bx, cl
          mov    ax, ss
          add    bx, ax
          mov    ax, es
          sub    bx, ax
          mov    ah, 4Ah
          int    21h
          ; 㫥 ६
          push   es
          push   ds
          pop    es
          mov    di, offset SbPort
          mov    cx, LastByte - SbPort
          xor    al, al
          cld
          rep    stosb
          pop    es
          ; 樠 ᮯ
          call   InitFpu
          jnc    @@cm
          mov    ah, seFpu
          call   ErrorText
          jmp    @@Q

@@cm:     ; 㬠稢 祭  ६
          mov    [SbFreq], 11
          mov    [Volume], 12
          mov    [SBuferSize], 65535
          ; ࠧ  ப
          call   GetCommand
          jnc    @@mb
          jmp    @@Q

          ;     ନ஢ 㪠
@@mb:     mov    bx, [SBuferSize]
          mov    cl, 4
          shr    bx, cl
          inc    bx
          mov    ah, 48h
          int    21h
          mov    [SBufer], ax
          jnc    @@mn
          mov    ah, seMemory
          call   ErrorText
          jmp    @@Q

@@mn:     ; ࠧ 
          cmp    [Command], 1
          je     @@da
          cmp    [Command], 3
          je     @@df
          cmp    [Command], 2
          je     @@dt
          cmp    [Command], 4
          je     @@dt
          jmp    @@Q

@@da:     ; ନ஢ ࢠ쭮 
          call   MakeDisaon
          jnc    @@sb
          jmp    @@Q

@@dt:     ; ନ஢  DTMF  CCITT
          call   MakeDTMF
          jnc    @@sb
          jmp    @@Q


@@df:     ; ନ஢ ⤥ 
          call   MakeFreq
          jnc    @@sb
          jmp    @@Q

@@sb:     ; 樠 㪮 
          call   SbDetect
          jnc    @@sm
          mov    ah, seSb
          call   ErrorText
          jmp    short @@Q
@@sm:     ; ⠭ SB IRQ
          call   SetSbIrq
           ; ன  SB
          mov    bl, MMidi
          mov    ax, 0808h
          call   WriteMixer
          mov    bl, MLine
          mov    ax, 0
          call   WriteMixer
          mov    bl, MMaster
          mov    ax, 0F0Fh
          call   WriteMixer
          mov    bl, MVoice
          mov    al, [Volume]
          mov    ah, al             ;    ࠢ 
          call   WriteMixer
          ; ந 㪠
          call   Play
          ; ᢮ 
          mov    es, [SBufer]
          mov    ah, 49h
          int    21h
@@Q:      ; 室  DOS
          mov    ah, 4Ch
          mov    al, [DosExitCode]  ;  訡
          int    21h
;--------------------------------------------------------------------------
PROC      InitSB          ; 樠 SB
                          ;  In:    none
                          ;  out:   JC=1 訡
          mov    dx, [SbPort]
          mov    bh, [SbFreq]
          push   ds
          pop    es
          mov    di, offset SbWriteData
          mov    ax, SWriteData
          add    ax, dx
          stosw
          mov    ax, SReadData
          add    ax, dx
          stosw
          mov    ax, SReset
          add    ax, dx
          stosw
          mov    ax, SWriteStatus
          add    ax, dx
          stosw
          mov    ax, SDataAvail
          add    ax, dx
          stosw
          mov    ax, MixerAddr
          add    ax, dx
          stosw
          mov    ax, MixerData
          add    ax, dx
          stosw
          mov    dx, [SbReset]
          mov    al, 1
          out    dx, al
          mov    cx, 4
@@sc:     in     al, dx
          loop   @@sc
          call   Delay
          mov    al, 0
          out    dx, al
          mov    cx, 100
          mov    dx, [SbReadData]
@@sb:     in     al, dx
          cmp    al, 0AAh
          je     @@sa
          loop   @@sb
          jmp    short @@se
@@sa:     ; 祭  ந
          call   Delay
          mov    [SbBusy], 0
          mov    bl, SbON
          call   WriteDsp
          mov    bl, SbTime
          call   WriteDsp
          ; ⠭  ⨧樨
          cmp    bh, 11
          jnz    @@sf
          mov    bl, Sb11kgz
          call   WriteDsp
@@sf:     cmp    bh, 22
          jnz    @@sh
          mov    bl, Sb22kgz
          call   WriteDsp
@@sh:     cmp    bh, 44
          jnz    @@sm
          mov    bl, Sb44kgz
          call   WriteDsp
@@sm:     clc
          ret
@@se:     stc
          ret

ENDP
;---------------------------------------------------------------------------
PROC      SetSbIrq        ; ⠭ ࠡ稪 뢠 SB
          mov    bl, [SbIrq]
          push   ds
          push   cs
          pop    ds
          mov    dx, offset cs:MEMIRQ
          cmp    bl, 7
          ja     @@epa
          mov    ax, 2508h
          add    al, bl
          int    21h
          jmp    short @@epb
@@epa:    mov    ax, 2568h
          add    al, bl
          int    21h
@@epb:    pop    ds
          ret
ENDP
;--------------------------------------------------------------------------
PROC      WriteDsp          ; ⠭ 祭  ॣ DSP
          push   cx
          xor    cx, cx
@@nxtr:   mov    dx, [SbWriteStatus]
          in     al, dx
          test   al, 80h
          jz     @@writ
          loop   @@nxtr
          ; 訡   DSP
          jmp    short @@abrt
@@writ:   mov    dx, [SbWriteData]
          mov    al, bl
          out    dx, al
@@abrt:   pop    cx
          ret
ENDP
;---------------------------------------------------------------------------
PROC      DMAsetup          ; ன DMA #1

          push   bx cx dx si di
          pushf
          mov di, [DMAofs1]
          mov cl, [DMApge1]
         ; 48h (  +DMA  #1 ( ० )
         ; CL:DI  
         ; SI    DMA
@@a:      mov    al, 05h    ;  ᪨ DMA
          out    0Ah, al
          out    0Ch, al    ;  flip-flop ॣ
          mov    al, 49h    ; ⠭ ० DMA
          out    0Bh, al
          mov    ax, di     ; ⮢  
          out    02h, al
          mov    al, ah
          out    02h, al
          mov    ax, [szb]  ; ࠧ 
          out    3h, al
          mov    al, ah
          out    3h, al
          mov    al, cl     ; ⠭ ࠭ 
          out    83h, al
          mov    al, 01h    ;  ᪨ DMA
          out    0Ah, al
@@z:      popf
          pop    di si dx cx bx
          mov    ax, [szb]
          add    ax, [DMAofs1]
          jnc    @ld
          mov    al,0
          jmp    @le
@ld:      mov    al,01h
@le:      ret
ENDP
;-------------------------------------------------------------------------
PROC      DMAreset          ;  DMA #1
          push   ax dx
          mov    al, 05h    ; ⠭ ᪨ DMA
          out    0Ah, al
          sub    al, al     ;  flip-flop ॣ
          mov    al, 00h
          out    0Ch, al
          mov    al,01h     ;  DMA ᪨
          out    0Ah, al
          pop    dx ax
          ret
ENDP
;-------------------------------------------------------------------------
PROC      MemPlay           ; ந뢠 ,  室
                            ;   DOS
                            ; in:  ES:DI =  ࠣ  
                            ;         CX =  ࠣ
                            ; out: none

          mov    [size1], cx
          mov    ax, es
          mov    cl, 0Ch
          ror    ax, cl
          and    ax, 0Fh
          mov    [DMApge1], al
          mov    ax, es
          and    ax, 0FFFh
          mov    cl, 4
          rol    ax, cl
          add    ax, di
          mov    [DMAofs1], ax
          cmp    [SbIrq], 7
          ja     @@epk
          in     al, 21h
          mov    bl, 1
          mov    cl, [SbIrq]
          rol    bl, cl
          not    bl
          and    al, bl
          out    21h, al
          jmp    @@epn
@@epk:    in     al, 0A1h
          and    al, 0FBh
          out    0A1h, al
@@epn:    mov    [DMAok1], 1
          cmp    [SbIrq], 05h
          jnz    @@epl
          int    0Dh
          jmp    @@epz
@@epl:    cmp    [SbIrq], 07h
          jnz    @@epm
          int    0Fh
          jmp    @@epz
@@epm:    int    72h
@@epz:    ret
ENDP
;-------------------------------------------------------------------------
PROC      MEMIRQ far        ; ࠡ稪 ⭮ 뢠
                            ; 㪮 
          push   ax bx cx dx si di ds es
          mov    ax, @data
          mov    ds, ax
          mov    dx, [SbDataAvail]
          in     al, dx
          mov    al, [DMAok1]
          mov    [SbBusy], al
          cmp    [SbBusy], 0
          jz     @@emz
          mov    dx, [DMAofs1]
          not    dx
          mov    ax, [size1]
          cmp    ax, dx
          ja     @@ema
          mov    [szb], ax
          mov    [DMAok1], 0
          jmp    @@emb
@@ema:    mov    [szb], dx
@@emb:    cmp    [SbFreq], 44
          jz     @@emc
          cmp    [SbFreq], 50
          jz     @@emc
          mov    bl, SbDMAWrite
          call   WriteDsp
          mov    cx, [szb]
          mov    bl, cl
          call   WriteDsp
          mov    bl, ch
          call   WriteDsp
          jmp    @@emd
@@emc:    mov    bl, SbProInit
          call   WriteDsp
          mov    cx, [szb]
          mov    bl, cl
          call   WriteDsp
          mov    bl, ch
          call   WriteDsp
          mov    bl, SbProStart
          call   WriteDsp
@@emd:    call   DMAreset
          call   DMAsetup
          add    [DMApge1], 1
          mov    [DMAofs1], 0
          mov    ax, [szb]
          sub    [size1], ax
@@emz:    mov    al, 20h
          out    20h, al
          mov    al, 20h
          out    0A0h, al
          pop    es ds di si dx cx bx ax
          iret
ENDP
;--------------------------------------------------------------------------
PROC      StopPlay              ; ⠭ ந 㪠
          cmp    [SbBusy] ,0
          jz     @sta
          mov    bl, SbHalt
          call   WriteDsp
@sta:     ret
ENDP
;--------------------------------------------------------------------------
PROC      ReadMixer             ; ⠥  
                                ; in: BL = ⨯ ன⢠
                                ; MMaster 22h    ஬
                                ; MVoice  04h   ஬ ஢ ந뢠⥫
                                ; MMidi   2Eh   ஬ ᨭ⥧(MIDI)
                                ; MLine   26h   ஬ 
                                ; MCD     28h   ஬ 㪠 CD 모
                                ; out:    AL =  ஢ .. ( 0-3)
                                ;         AH =  ஢ .. ( 0-3)
          cli
          mov    dx, [SbMixerAddr]
          mov    al, bl
          out    dx, al
          mov    dx, [SbMixerData]
          in     al, dx
          mov    ah, al
          mov    cl, 4
          shr    ah, cl
          and    ax, 0F0Fh
          sti
          ret
ENDP
;--------------------------------------------------------------------------
PROC      WriteMixer            ; ⠭  
                                ; in:  BL = ⨯ ன⢠
                                ;      AL = ஢ .. ( 0-3)
                                ;      AH = ஢ .. ( 0-3)
                                ; out: none
          cli
          push   ax
          xor    al, al
          mov    dx, [SbMixerAddr]
          out    dx, al
          mov    al, bl
          out    dx, al
          pop    ax
          and    al, 0Fh
          mov    cl, 4
          shl    ah, cl
          or     al, ah
          mov    dx, [SbMixerData]
          out    dx, al
          sti
          ret
ENDP
;--------------------------------------------------------------------------
PROC      SbDetect                      ; ⥪ 稥, 
                                        ;    IRQ  㪮 
                                        ;  in: none
                                        ; out: JC=1 訡

          ; 室    / 
          cmp    [SbPort], 0
          jnz    @@dp                   ;  㦥 
          xor    di, di
          mov    cx, 9
@@da:     mov    ax, 10h
          mul    di
          add    ax, 200h
          mov    bx, ax
          mov    dx, SReset
          add    dx, bx
          mov    al, 1
          out    dx, al
          push   cx
          mov    cx, 4
@@db:     in     al, dx
          loop   @@db
          pop    cx
          xor    al, al
          out    dx, al
          call   Delay
          mov    dx, SReadData
          add    dx, bx
          mov    si, 20
@@dc:     in     al, dx
          cmp    al, 0AAh
          je     @@dd
          dec    si
          jnz    @@dc
          inc    di
          loop   @@da
          ;    
          stc
          ret

@@dd:     mov    [SbPort], bx
@@dp:     cmp    [SbIrq], 0
          jz     @@gq
          ; Irq 㦥 
          call   InitSB
          ret

          ; 室 IRQ
@@gq:     mov    ax, 350Dh
          int    21h
          mov    [word old5+2], es
          mov    [word old5+0], bx
          mov    ax, 350Fh
          int    21h
          mov    [word old7+2], es
          mov    [word old7+0], bx
          mov    ax, 3572h
          int    21h
          mov    [word old10+2], es
          mov    [word old10+0], bx
          ; 蠥 ᢮ ࠡ稪  
          ; 騥   IRQ
          push   ds
          push   cs
          pop    ds
          mov    ax, 250Dh
          mov    dx, offset cs:Test05     ; IRQ 5
          int    21h
          mov    ax, 250Fh
          mov    dx, offset cs:Test07     ; IRQ 7
          int    21h
          mov    ax, 2572h
          mov    dx, offset cs:Test10     ; IRQ 10
          int    21h
          pop    ds
          ; 樨  ஫஬ 뢠
          cli
          in     al, 21h
          mov    [old21], al
          and    al, 53h
          out    21h, al
          in     al, 0A1h
          mov    [oldA1], al
          and    al, 0FBh
          out    0A1h, al
          sti
          call   InitSB
          mov    bh, 1
          jc     @@de
          xor    bh, bh
          ; 㥬 IRQ  
          call   Delay
          mov    bl, SbIntRequest
          call   WriteDsp
          call   Delay
          mov    bh, 1
          cmp    [SbIrq], 0               ; ஢塞  IRQ
          jz     @@de                     ;  , 訡
          xor    bh, bh
@@de:     cli
          ; . ஫ 뢠  . ﭨ
          mov    al, [old21]
          out    21h, al
          mov    al, [oldA1]
          out    0A1h, al
          ; ⪫砥  ࠡ稪
          mov    cx, 3
@@df:     push   ds
          loop   @@df
          mov    ax, 250Dh
          lds    dx, [old5]
          int    21h
          pop    ds
          mov    ax, 250Fh
          lds    dx, [old7]
          int    21h
          pop    ds
          mov    ax, 2572h
          lds    dx, [old10]
          int    21h
          pop    ds
          or     bh, bh                   ; 䫠  ஢ન IRQ
          jz     @@dk                     ; ᫨  0 - 訡
          stc
@@dk:     ret
ENDP
;--------------------------------------------------------------------------
PROC      Delay       ; প  32768  横
          push   cx
          mov    cx, 32768
@@la:     jmp    short @@lb
@@lb:     jmp    short @@ld
@@ld:     jmp    short @@le
@@le:     loop   @@ld
          pop    cx
          ret
ENDP
;--------------------------------------------------------------------------
PROC      Test05 far
          push   ax dx ds
          mov    ax, @data
          mov    ds, ax
          mov    dx, [SbDataAvail]
          in     al, dx
          mov    [SbIrq], 5
          mov    al, 20h
          out    20h, al
          mov    al, 20h
          out    0A0h, al
          pop    ds dx ax
          iret
ENDP
;--------------------------------------------------------------------------
PROC      Test07 far
          push   ax dx ds
          mov    ax, @data
          mov    ds, ax
          mov    dx, [SbDataAvail]
          in     al, dx
          mov    [SbIrq], 7
          mov    al, 20h
          out    20h, al
          mov    al, 20h
          out    0A0h,al
          pop    ds dx ax
          iret
ENDP
;--------------------------------------------------------------------------
PROC      Test10 far
          push   ax dx ds
          mov    ax, @data
          mov    ds, ax
          mov    dx, [SbDataAvail]
          in     al, dx
          mov    [SbIrq], 10
          mov    al, 20h
          out    20h, al
          mov    al, 20h
          out    0A0h, al
          pop    ds dx ax
          iret
ENDP
;---------------------------------------------------------------------------
PROC      Play                     ; 横 ந 㪠
          call   InitBreak
          mov    al, 7
          mov    dx, offset PressKey
          call   PrintString       ; ᪠  蠬
          mov    al, 15
          mov    dx, offset Repeat ; 뢮 ப ':'
          call   PrintString
          call   GetCursor
          mov    [Cursor], dx      ; ࠭ 

          mov    cx, [PlayLoop]    ; ᫮ ७
          xor    si, si            ; 稪 ७
          call   @@DispRep         ; 뢥

@@play:   ; 砫 () ந
          cmp    [Cancel], 0       ; ⬥?
          jz     @@noESC           ;  - த
@@paESC:  jmp    @@endl

@@noESC:  cmp    [WaitKey], 0      ;  㧠?
          jz     @@nopa            ;  -  ந
          mov    [WaitKey], 0
          ; 㧠 祭
          call   GetCursor
          mov    bp, dx
          mov    dx, offset PauseMsg
          mov    al, 15
          call   PrintString

@@paul:   call   GetKey
          jz     @@paul
          jnc    @@keyp
          jmp    @@break

@@keyp:   ;  
          push   ax cx
          mov    dx, bp
          call   SetCursor
          mov    cx, 20
          call   ClrEOL
          pop    cx ax
          cmp    ax, 011Bh         ; ESC?
          je     @@paESC           ; ⬥

@@nopa:   ;    
          push   cx si
          mov    es, [SBufer]
          mov    cx, [SoundSize]
          xor    di, di
          call   MemPlay
          pop    si cx
          inc    si
          call   @@DispRep

@@plop:   ;   
          call   GetKey
          jc     @@break
          jz     @@wait
          ;  
          cmp    ax, 011Bh         ; ESC
          je     @@stop
          cmp    al, 2Bh           ; '+'
          je     @@voluP
          cmp    al, 2Dh           ; '-'
          je     @@voluM
          cmp    al, 20h           ; ' '
          je     @@paun
          or     al, 20h
          cmp    al, 70h           ; 'p'
          je     @@paun
          cmp    al, 6Dh           ; 'm'
          je     @@mute
          jmp    short @@wait

@@stop:    ;  ESC
          mov    [Cancel], 1
          jmp    short @@wait

@@mute:    ; -몫 ᨣ

          jmp    short @@wait

@@paun:    ; 㧠 - 
          mov    [WaitKey], 1
          jmp    short @@wait

@@voluP:   ; ஢ - 


          jmp    short @@wait


@@voluM:  ; ஢ - 


@@wait:   ;   ந뢠 ࠣ
          cmp    [SbBusy], 0
          jnz    @@plop
          mov    al, [AutoPause]
          or     [WaitKey], al
          ; த ந
          loop   @@play0
          jmp    short @@endl
@@play0:  jmp    @@play


@@endl:   ;  ७   ESC
          mov    al, 15
          mov    dx, offset StopMsg
          call   PrintString       ; 뢮 ப "⮯"
          call   PrintCRLF
          jmp    short @@Q

@@break:  ;  Ctrl-Break
          mov    ah, seBreak
          call   ErrorText
@@Q:      call   StopPlay
          call   DoneBreak
          ret

@@DispRep: ; 뢮 稪 ७
          push   cx
          mov    di, offset DigitBufer
          mov    ax, si
          call   BinToDec
          mov    ah, 02
          mov    dx, [Cursor]
          call   SetCursor
          mov    dx, offset DigitBufer
          mov    al, 14
          call   PrintString
          pop    cx
          ret

ENDP
;--------------------------------------------------------------------------
PROC      InitBreak
          ; save & set Ctrl-Break status
          mov    ax, 3300h
          int    21h
          mov    [SaveBreak], dl
          mov    [BreakFlag], 2
          mov    ax,3301h
          mov    dl, 1
          int    21h
          ; get Ctrl-Break interrupt vector
          mov    ax, 351Bh
          int    21h
          mov    [word OldInt1B+0], bx
          mov    [word OldInt1B+2], es
          push   ds
          push   cs
          pop    ds
          ; set interrupt handler 1B
          mov    dx, offset cs:BreakHandler
          mov    ax, 251Bh
          int    21h
          pop    ds
          ret
ENDP
;--------------------------------------------------------------------------
PROC      DoneBreak
          ; restore Ctrl-Break status
          push    ds
          mov     ax, 3301h
          mov     dl, [SaveBreak]
          int     21h
          ; restore original INT 1B handler
          mov     ax, 251Bh
          lds     dx, [OldInt1B]
          int     21h
          pop     ds
          ret
ENDP
;--------------------------------------------------------------------------
PROC      BreakHandler  far              ; ࠡ稪 Ctrl-Break
          push    ds ax
          xor     ax, ax
          mov     ds, ax
          and     [byte ds:471h], 7Fh    ; clear DOS Ctrl-Break flag
          mov     ax, @data
          mov     ds, ax
          mov     [BreakFlag], 0
          pop     ax ds
          iret
ENDP
;--------------------------------------------------------------------------
PROC      GetKey            ; 訢 
                            ; 頥 JZ=1 ᫨   
                            ;            JC=1 ᫨  Ctrl-Break
                            ;  AX=ASCII    
          mov    ah, 1
          int    16h
          jz     @@nbr
          ; was key pressed
          xor    ah, ah
          int    16h
          cmp    [BreakFlag], 1
          jnz    @@nbr
          ; was Ctrl-Break pressed
          mov    [BreakFlag], 2
@@nbr:    ret
ENDP
;--------------------------------------------------------------------------
PROC     ASCII_Bin          ; ॢ ASCIIZ ப  DS:SI  Bin.
                            ; AH=0 . ᫮
                            ; AH=1 ᭠筮 ᫮
                            ; 頥  AX ᫮
                            ; ᫨ JC=1  ᫨ ப 
                            ;  . ᫮  0FFFFh
          push   cx dx di es
          push   ds
          pop    es
          mov    di, si
          mov    dx, di
          mov    cx, 7
          xor    al, al
          repne  scasb        ; 室  ப
          dec    di
          mov    cx, di
          sub    cx, dx
          jcxz   @@se
          cmp    cx, 5
          ja     @@se
          xor    bx, bx
          or     ah, ah
          mov    ax, 0
          jz     @@dc
          xor    dx, dx
         ; . ᫮
          cmp    cx, 4
          ja     @@se
          std
          mov    si, di
          dec    si
@@hx:     lodsb
          sub    al, 30h
          cmp    al, 9
          ja     @@da
          jmp    short @@cn
@@da:     and    al, 0DFh
          sub    al, 7
@@cn:     push   cx
          mov    cl, bl
          shl    ax, cl
          or     dx, ax
          pop    cx
          add    bl, 4
          loop   @@hx
          xchg   ax, dx
          cld
          jmp    short @@so
@@dc:     ; . ᫮
          mul    [Ten]
          jc     @@se
          mov    bl, [si]
          inc    si
          sub    bl, 30h
          add    ax, bx
          jc     @@se
          loop   @@dc
          inc    si
          jmp    short @@so
@@se:     stc
@@so:     pop    es di dx cx
          ret
ENDP
;--------------------------------------------------------------------------
PROC      BinToDec           ; ॢ Bin  ASCII  뢮
                             ; in : AX = ᫮
                             ; DS:DI = 
          push   cx
          push   ds
          pop    es
          mov    cx,0
@@da:     mov    dx,0
          div    [Ten]
          push   dx
          inc    cx
          cmp    ax,0
          jne    @@da
@@db:     pop    ax
          or     al, 30h
          stosb
          loop   @@db
          xor    al, al
          stosb
          pop    cx
          ret
ENDP
;--------------------------------------------------------------------------
PROC      PrintString ; 뢮 ASCIIZ ப
                      ; in: DS:DX = ப
                      ; AL = ਡ
          push   bx cx dx bp
          push   ds
          pop    es
          mov    di, dx
          mov    cx, 2000
          cmp    [DosPrint], 0
          jz     @@bio
          ; 뢮 १ DOS
@@dop:    mov    dl, [di]
          inc    di
          or     dl, dl
          jz     @@dz
          mov    ah, 02
          int    21h
          loop   @@dop
@@dz:     jmp    short @@pr

@@bio:    ; 뢮 १ BIOS
          xor    bh, bh
          mov    bl, al
          call   GetCursor
          mov    bp, di
          xor    al, al
          repne  scasb
          dec    di
          sub    di, bp
          mov    cx, di
          mov    ax, 1301h
          int    10h
@@pr:     pop    bp dx cx bx
          ret
ENDP
;--------------------------------------------------------------------------
PROC      PrintCRLF                ; 뢮 <CR+LF>  ⠢  
                                   ; ப ଠ ਡ.
          mov    al, 7
          mov    dx, offset CRLF
          call   PrintString
          call   GetCursor
          dec    dl
          call   SetCursor
          ret
ENDP
;--------------------------------------------------------------------------
PROC      GetCursor                 ; 頥  DX . 
          push   ax bx cx
          xor    bx, bx
          mov    ah, 3
          int    10h
          pop    cx bx ax
          ret
ENDP
;--------------------------------------------------------------------------
PROC      SetCursor                 ; ⠢   . DX
          push   ax bx
          mov    ah, 02
          xor    bx, bx
          int    10h
          pop    bx ax
          ret
ENDP
;-------------------------------------------------------------------------
PROC      ClrEOL                    ; 頥 ப   ஡,
                                    ; ᫮    CX.
          jcxz   @@er
          call   GetCursor
          mov    ax, 0720h
          call   PrintChar
          call   SetCursor
@@er:     ret
ENDP
;-------------------------------------------------------------------------
PROC      PrintChar                 ; ⠥ CX ᨬ AL ਡ⮬ AH
                                    ;  ६頥 .
          push   bx dx
          jcxz   @@er
          cmp    [DosPrint], 0
          jz     @@bio
          mov    dl, al
@@dol:    mov    ah, 02
          int    21h
          loop   @@dol
          jmp    short @@er

@@bio:    call   GetCursor
          add    dl, cl
          push   dx
          mov    bx, 09
          xchg   ah, bl
          int    10h
          pop    dx
          call   SetCursor
@@er:     pop    dx bx
          ret
ENDP
;-------------------------------------------------------------------------
PROC      HelpScreen                ; 뢮 ࠩ   ணࠬ
          mov    dx, offset HelpDisaon
          mov    al, 15
          call   PrintString
          mov    dx, offset Vers
          mov    al, 14
          call   PrintString
          mov    dx, offset Copyright
          mov    al, 7
          call   PrintString
          mov    dx, offset HelpText
          mov    al, 3
          call   PrintString
          ret
ENDP
;--------------------------------------------------------------------------
PROC      ErrorText                 ; 뢮 ᮮ饭  訡.
                                    ;  訡  AH
          mov    [DosExitCode], ah
          mov    dx, offset MemErr
          cmp    ah, seMemory
          je     @@e1
          mov    dx, offset FpuErr
          cmp    ah, seFpu
          je     @@e1
          mov    dx, offset CmdErr
          cmp    ah, seCmd
          je     @@e1
          mov    dx, offset ArgErr0
          cmp    ah, seArg0
          je     @@e1
          mov    dx, offset ArgErr1
          cmp    ah, seArg1
          je     @@e1
          mov    dx, offset ArgErr2
          cmp    ah, seArg2
          je     @@e1
          mov    dx, offset ArgErr3
          cmp    ah, seArg3
          je     @@e1
          mov    dx, offset ArgErr4
          cmp    ah, seArg4
          je     @@e1
          mov    dx, offset OptErr
          cmp    ah, seOpt
          je     @@e1
          mov    dx, offset SbErr
          cmp    ah, seSb
          je     @@e1
          mov    dx, offset CtrlBreak
          cmp    ah, seBreak
          mov    al, 15
          je     @@e2
          ; 뢥 
          call   HelpScreen
          jmp    short @@spc
          ret
@@e1:     ; 訡
          inc    [DosPrint]
@@e2:     call   PrintString
@@spc:    call   PrintCRLF
          ret
ENDP
;--------------------------------------------------------------------------
PROC      GetCommand          ; ࠧ  ப
                              ;  in: ES ᥣ PSP
                              ; out: JC=1 ப   訡().
          mov    di, 81h
          mov    cl, [es:di-1]
          cmp    cl, 1
          ja     @@gc
          mov    ah, seHelp
@@hl:     call   ErrorText
          jmp    short @@er

@@gc:     call   SkSpace
          jcxz   @@hl
          call   @@GtCmd      ;  
          jnc    @@ga
          mov    ah, seCmd
          call   ErrorText
          jmp    short @@er

@@ae:     mov    ah, seArg0
          call   ErrorText
          jmp    short @@er

@@ga:     mov    [Command], ah
          cmp    ah, 5        ; ᨫ help?
          jne    @@nh
          dec    di           ;  -  ⠪, ⮡ 'h'  '?'
          inc    cx           ; ᨬ     ப 㬥⮢
@@nh:     call   SkSpace
          jcxz   @@ae
          mov    si, offset NomerIn
          call   @@GtArg      ;  㬥
          or     cx, cx
          jz     @@em
          call   @@GtOpt      ;  樨
          jnc    @@em
          mov    ah, seOpt
          call   ErrorText
@@er:     stc
          ret

@@em:     mov    ah, seHelp
          cmp    [Command], 5
          je     @@hl
          clc
          ret

          ; 砥  頥  AH 
          ; JC=1   ୮
@@GtCmd:  cmp    al, '-'
          jne    @@ce
          inc    di
          dec    cx
          call   SkSpace
          jcxz   @@ce
          dec    cx
          inc    di
          mov    ah, 5
          cmp    al, '?'
          je     @@co
          mov    ah, 1
          and    al, 0DFh
          cmp    al, 'A'
          je     @@co
          inc    ah
          cmp    al, 'D'
          je     @@co
          inc    ah
          cmp    al, 'F'
          je     @@co
          inc    ah
          cmp    al, 'C'
          je     @@co
          inc    ah
          cmp    al, 'H'
          je     @@co
          xor    ah, ah
@@ce:     stc
@@co:     ret

          ; 祭 㬥⮢
@@GtArg:  mov    al, [es:di]
          cmp    al, '/'
          je     @@ea
          inc    di
          jcxz   @@ea
          dec    cx
          mov    [si], al
          inc    si
          jmp    short @@GtArg
@@ea:     ; 㡨ࠥ ஡  
          ; 室 ப 㬥⮢
          mov    [byte si], 0
          dec    si
          mov    al, [si]
          cmp    al, 20h
          je     @@ea
          cmp    al, 9
          je     @@ea
          ret

@@op:     ;  '/p'
          inc    [WaitKey]
          jmp    short @@GtOpt

@@ow:     ;  '/w'
          inc    [AutoPause]
          jmp    short @@GtOpt

@@ob:     ; '/b'
          inc    [DosPrint]
          jmp    short @@GtOpt

@@oi:     inc    [SbInfo]

@@GtOpt:  ; ࠧࠥ 樨
          ; 頥 JC=1  訡
          call   SkSpace
          or     cx, cx
          jz     @@oo
          cmp    al, '/'
          jne    @@oe
          dec    cx
          inc    di
          call   SkSpace
          jcxz   @@oe
          dec    cx
          inc    di
          and    al, 0DFh
          cmp    al, 'P'
          je     @@op
          cmp    al, 'W'
          je     @@ow
          cmp    al, 'B'
          je     @@ob
          cmp    al, 'I'
          je     @@oi

          cmp    al, 'L'
          je     @@ol
          cmp    al, 'V'
          je     @@ov
          cmp    al, 'A'
          je     @@oa
          cmp    al, 'Q'
          je     @@oq
          cmp    al, 'D'
          je     @@od
          cmp    al, 'T'
          je     @@ot
          cmp    al, 'S'
          je     @@os
@@oe:     stc
@@oo:     ret

@@os:     jmp    @@os1

@@ol:     ;  '/l'
          xor    ah, ah
          call   @@StOpt
          jc     @@oe
          mov    [PlayLoop], ax
          jmp    short @@GtOpt

@@ov:     ;  '/v'
          xor    ah, ah
          call   @@StOpt
          jc     @@oe
          cmp    ax, 15
          ja     @@oe
          mov    [Volume], al
          jmp    short @@GtOpt

@@oa:     ;  '/a'
          mov    ah, 1
          call   @@StOpt
          jc     @@oe
          cmp    ax, 200h
          jb     @@oe
          cmp    ax, 290h
          ja     @@oe
          mov    [SbPort], ax
          jmp    short @@GtOpt

@@oq:     ;  '/q'
          xor    ah, ah
          call   @@StOpt
          jc     @@oe
          cmp    ax, 5
          je     @@si
          cmp    ax, 7
          je     @@si
          cmp    ax, 10
          jne    @@oe
@@si:     mov    [SbIrq], al
          jmp    @@GtOpt

@@od:     ;  '/d'
          xor    ah, ah
          call   @@StOpt
          jc     @@oe
          cmp    ax, 11
          je     @@do
          cmp    ax, 22
          je     @@do
          cmp    ax, 44
          jne    @@oe
@@do:     mov    [SbFreq], al
          jmp    @@GtOpt

@@ot:     ;  '/t'
          xor    ah, ah
          call   @@StOpt
          jc     @@et
          cmp    ax, 9
          jb     @@et
          cmp    ax, 99
          ja     @@et
          mov    [DelayAon], ax
          jmp    @@GtOpt
@@et:     jmp    @@oe

@@os1:     ;  '/s'
          xor    ah, ah
          call   @@StOpt
          jc     @@eo
          cmp    ax, 99
          ja     @@eo
          mov    [PauseDig], ax
          jmp    @@GtOpt
@@eo:     jmp    @@oe

          ; ⠭ ࠬ 樨
          ; in:  ES:DI = ᫥. ᨬ  . ப ᫥ 㪢 樨
          ;      AH = 室 ᫮ .  16-筮
          ; out: AX   祭 㬥
          ;      JC=1 訡 㬥
@@StOpt:  call   SkSpace
          jcxz   @@se
          cmp    al, 3Dh    ;'='
          jne    @@se
          inc    di
          dec    cx
          call   SkSpace
          jcxz   @@se
          ; 㥬 . 㬥 樨  ,
          ;  ஢塞  ࠬ஢
          mov    si, offset DigitBufer
@@cpd:    mov    al, [byte es:di]
          cmp    al, 0Dh    ; CR
          je     @@sc
          cmp    al, 20h    ; ' '
          je     @@sc
          cmp    al, 9h     ; Tab
          je     @@sc
          inc    di
          cmp    al, 30h    ; '0'
          jb     @@hx
          cmp    al, 39h    ; '9'
          ja     @@hx
          jmp    short @@cpc
@@hx:     or     ah, ah
          jz     @@se
          ; 16 筮 ᫮
          and    al, 0DFh
          cmp    al, 41h    ; 'A'
          jb     @@sh
          cmp    al, 46h    ; 'F'
          ja     @@sh
          jmp    short @@cpc
@@sh:     cmp    al, 48h    ; 'H'
          jne    @@se
          jcxz   @@sc
          dec    cx
          jmp    short @@sc

@@cpc:    mov    [si], al
          inc    si
          jcxz   @@sc
          dec    cx
          jmp    short @@cpd

@@sc:     xor    al, al
          mov    [si], al     ; 塞  ப 0
          mov    si, offset DigitBufer
          call   ASCII_Bin
          ret
@@se:     stc
          ret
ENDP
;--------------------------------------------------------------------------
PROC      SkSpace             ; ய᪠ ⠡  ஡  ES:DI
                              ; out: AL=᫥.  ஡ ᨬ
                              ;      CX=0 ᫨ ப 
          mov    al, [es:di]
          cmp    al, 20h
          je     @@ki
          cmp    al, 9h
          je     @@ki
@@k0:     ret
@@ki:     jcxz   @@k0
          dec    cx
          inc    di
          jmp    short SkSpace
ENDP
;--------------------------------------------------------------------------
PROC      CalcLeng           ; 頥  CX  ASCIIZ ப
                             ; ES:DI 㪠뢠   ப
          push   ds
          pop    es
          mov    cx, 80
          mov    di, offset NomerIn
          mov    dx, di
          xor    al, al
          repne  scasb       ; 饬 
          dec    di
          mov    cx, di
          sub    cx, dx
          mov    ah, seArg0  ;  訡 ⢨ 㬥⮢
@@ea:     ret
ENDP
;--------------------------------------------------------------------------
PROC      CompPause         ;  ᪮쪮  ⮢  
                            ;   ய,  ⮡  믮
                            ;    ᫮ ᥪ㭤
                            ; in:  BP ॡ㥬 㧠  
                            ; out: BP ᪮쪮   ய
          or     bp, bp
          jz     @@nd
          push   dx
          xor    ax, ax
          mov    al, [SbFreq]
          mul    bp
          xchg   ax, bp           ; ॠ쭠 稭 প  BP
          pop    dx
@@nd:     ret
ENDP
;--------------------------------------------------------------------------
PROC      Make2Tone          ; ନ   ᨣ
                             ; in:  DS:SI = ନ㥬 
                             ;      DS:BX = ⠡ 
                             ;      DX = ⥫쭮  ।  
                             ;      BP = 稭     ࠬ
                             ; out: CX = . ᢮   

          call   ClearSb          ;  Sb 
          call   CompPause        ; ᫨   ࠬ
@@nexd:   xor    ah, ah
          lodsb                   ; ६ 
          cmp    al, -1           ; ᫨ -1  
          je     @@cb
          ; ନ஢  
          push   bx
          shl    ax, 2
          add    bx, ax           ; ६ ॡ.   ⠡ 
          mov    ax, [bx+2]       ;  
          push   ax
          mov    ax, [bx+0]       ; ࢠ 
          mov    bl, 1
          push   cx di
          call   MakeSound        ; ନ㥬 ᨣ  1
          pop    di cx
          pop    ax
          mov    bl, 2
          call   MakeSound        ; ନ㥬 ᨣ  2
          pop    bx
          mov    ax, bp           ; 稭 
@@dly:    jcxz   @@cb             ;  , 
          or     ax, ax           ;  ?
          jz     @@nexd           ;  -  ᫥. 
          dec    ax
          dec    cx
          inc    di
          jmp    short @@dly      ; 㧠  ࠬ
@@cb:     ; 砥 ᫮ ,  ᨣ
          mov    ax, [SBuferSize]
          mov    [SoundSize], ax
          sub    [SoundSize], cx
          jcxz   @@er
          mov    al, 7
          mov    dx, offset Done
          call   PrintString
@@er:     call   PrintCRLF
          ret
ENDP
;--------------------------------------------------------------------------
PROC      ClearSb            ; ⪠  SB .    室 ES:DI
                             ; 㪠뢠  砫 , CX=ࠧ 
          mov    cx, [SBuferSize]
          mov    es, [SBufer]
          xor    di, di
          push   di cx
          xor    ax, ax
          rep    stosb
          pop    cx di
          ret
ENDP
;--------------------------------------------------------------------------
PROC      MakeFreq              ; ନ஢ ⤥   
                                ; 権

          call   CalcLeng
          or     cx, cx
          jnz    @@nz
          jmp    @@era

@@nz:     ; 㤠塞 譨 ஡  ப,
          ; ॢ ப  㣮 ଠ
          ;  ⠪ ஢  ᨭ⠪
          mov    di, offset NomerIn
          mov    bx, offset NomerOut
          xor    dx, dx

@@nd:     mov    al, [es:di]
          cmp    al, 30h        ; '0'
          jb     @@er0
          cmp    al, 39h        ; '9'
          ja     @@er0
          inc    dl             ; 䫠: -   뫠 㪠
@@cn:     mov    [bx], al
          inc    bx
          inc    di
@@sk:     loop   @@nd

@@er0:    or     dl, dl         ; 訡, ᫨  㪠   
          jz     @@er2
          xor    dl, dl
          mov    [byte bx], dl  ; 塞 0 ᫥ ਨ 
          inc    bx             ;   砥
          jcxz   @@er1
          cmp    al, 20h        ; ' '
          je     @@er1
          cmp    al, 9h         ; Tab
          je     @@er1
          cmp    al, 2Bh        ; '+'
          je     @@cn
          inc    dh             ; 䫠: ⠫쭮  㧠 뫠 
          cmp    al, 2Ch        ; ','
          je     @@cn
          ; ⨬ ᨬ
@@er2:    jmp    @@erb

@@er1:    or     dh, dh         ; ⥫쭮 뫠 ?
          jz     @@er2          ;  - 訡.
          cmp    dh, 2          ; 㧠 뫠 ?
          je     @@pae          ;  -  ᠭ ᨣ
          ja     @@er2          ; 訡 - ࠬ஢ ᫨誮 
          ;  䮫  (0)
          ; ᫨ ᫥ 뫠 饭
          mov    ax, 302Ch
          mov    [bx+0], ax     ; 襬  ப ',0'
          xor    al, al
          mov    [bx+2], al     ; 塞 0
          add    bx, 3
@@pae:    xor    dx, dx
          mov    al, 2Dh        ; '-'
          mov    [bx], al
          inc    bx
          call   SkSpace
          or     cx, cx
          jnz    @@nd

@@est:    mov    [bx], cx       ; 塞  ப 0

          ; ⥯  室 ப ࠬ  :
          ; 室,  짮⥫:
          ; 2600,50,30 [tab  ஡()] 500,80
          ;          ^ 㧠                ^ 㧠 饭
          ; 䨫஢ 室:
          ; 2600z,50z,30z-500z,80z,0z-z
          ;                           ^ z ᫥ '-'  ப
          ;  z - ASCII 0

          mov    bp, sp
          mov    si, offset NomerOut
          mov    di, offset NomerIn
          xor    cx, cx
          mov    dx, 1

          ; 뤥塞  ப ࠬ,
          ; ॢ   Bin, ஢塞
          ;  .

@@nex:    cmp    [byte si], 0
          jz     @@eos1         ;  ᠭ ᨣ
          xor    ah, ah
          call   ASCII_Bin
          jc     @@erc
          inc    cx
          push   ax             ; ࠬ ࠭塞  ⥪
          mov    ah, [si]
          inc    si
          cmp    ah, 2Ch        ; ','
          je     @@nex
          cmp    ah, 2Dh        ; '-'
          je     @@eos0         ;  ᠭ ᨣ
          inc    dx
          cmp    ah, 2Bh        ; '+'
          je     @@nex          ; ᫥.   ᨣ

@@erc:    ; ⨬  ᫮  
          ; 訡  室 ப
          mov    sp, bp
          jmp    @@erb

@@eos0:   ;  ᠭ ᨣ
          mov    ax, dx         ;  ᪮쪨  ⮨ ᨣ
          stosw
@@eosl:   pop    ax             ; ࠧ㦠  ⥪ ࠬ
          stosw                 ;  ⭮ 浪 
          loop   @@eosl
          mov    dx, 1
          jmp    short @@nex

@@eos1:   ;  ᠭ  ᨣ
          xor    ax, ax
          stosw                 ;  ᠭ ᨣ

          ; ==========================================================
          ; ⥯   ८ࠧ  筮 ଥ
          ; ࠬ  ᯮ    ᫥饬  浪:
          ; dw  ᫮ ,   ⮨ ᨣ (1, 2, 3, n)
          ; dw  㧠 ᫥ ந ᨣ  
          ; dw  ⥫쭮 ᨣ
          ; dw   1
          ; dw   2
          ; dw   n
          ; < ᤥ. ᨣ()>
          ; dw  0  ᠭ
          ;===========================================================

          ; 뢮 ଠ  ᨣ
          mov    si, offset NomerIn
@@lls:    lodsw
          mov    cx, ax      ; ᫮   ᨣ
          jcxz   @@wed
          lodsw
          push   ax          ; 稭 
          lodsw
          push   ax          ; ⥫쭮

          mov    dx, offset FreqFreq
          mov    al, 7
          call   PrintString
@@lpf:    lodsw
          mov    di, offset DigitBufer
          push   di
          call   BinToDec
          pop    dx
          mov    al, 15
          call   PrintString
          cmp    cx, 1
          jbe    @@npl
          ;   1, 뢮 '+'
          push   cx
          mov    cx, 1
          mov    ax, 0F2Bh
          call   PrintChar
          pop    cx
@@npl:    loop   @@lpf
          mov    al, 7
          mov    dx, offset Herz
          call   PrintString
          call   PrintCRLF
          mov    al, 7
          mov    dx, offset FreqDelay
          call   PrintString
          pop    ax                      ;  ⥪ ६ ⥫쭮
          mov    di, offset DigitBufer
          push   di
          call   BinToDec
          pop    dx
          mov    al, 15
          call   PrintString
          mov    dx, offset Msc
          mov    al, 7
          call   PrintString
          call   PrintCRLF

          mov    al, 7
          mov    dx, offset FreqPause
          call   PrintString
          pop    ax                      ; 稭 
          mov    di, offset DigitBufer
          push   di
          call   BinToDec
          pop    dx
          mov    al, 15
          call   PrintString
          mov    al, 7
          mov    dx, offset Msc
          call   PrintString
          call   PrintCRLF
          jmp    @@lls

@@wed:    call   ClearSb
          mov    si, offset NomerIn
          ; 横 ନ஢ ᨣ

@@nexs:   cmp    [word si], 0
          jz     @@ens          ; ஢ઠ  
          lodsw                 ;  ᪮쪨  ⮨ ᨣ
          mov    bh, al
          lodsw                 ; 㧠 । ᫥騬 ᨣ
          mov    bp, ax
          lodsw                 ; ⥫쭮 ᨣ
          mov    dx, ax
          call   CompPause      ; ᫨ 
          mov    bl, 1

@@nexf:   push   cx dx
          xor    cx, cx
          mov    ax, 1000
          mov    cl, [SbFreq]   ; 砥 1/2  
          mul    cx             ; ⨧樨 SB  
          pop    dx cx
          shr    ax, 1
          cmp    [si], ax
          ja     @@erb          ;     1/2  .
          cmp    [word si+0], 0
          jz     @@erb          ;    0

          push   di cx
          lodsw
          call   MakeSound      ; 㥬 ᨣ
          cmp    bl, bh
          je     @@nexg         ; ᫨ ମ ᫥ -  ᫥. ᨣ
          inc    bl
          mov    ax, cx
          pop    cx di
          or     ax, ax
          mov    ah, seArg3
          jz     @@era
          jmp    short @@nexf   ;  ᫥. ମ

@@nexg:   mov    ah, seArg3
          add    sp, 4
          mov    dx, bp         ; 稭 
@@dly:    jcxz   @@era          ; ९ 
          or     dx, dx         ;  ?
          jz     @@nexs         ;  -  ᫥. ᨣ
          dec    dx
          dec    cx
          inc    di
          jmp    short @@dly    ; 㧠  ࠬ

@@erb:    mov    ah, seArg4
@@era:    call   ErrorText
          stc
          ret

@@ens:    ; 砥 ᫮ ,  ᨣ

          mov    ax, [SBuferSize]
          mov    [SoundSize], ax
          sub    [SoundSize], cx
          clc
          ret

ENDP
;--------------------------------------------------------------------------
PROC      MakeDTMF              ; ନ஢ DTMF  CCITT 

          call   CalcLeng
          jcxz   @@era
          mov    si, offset NomerIn
          mov    di, offset NomerOut
          xor    dx, dx
@@cpn:    lodsb
          cmp    al, 30h        ; '0'
          jb     @@de0
          cmp    al, 39h        ; '9'
          ja     @@de0
          sub    al, 30h
@@wri:    inc    dx
          stosb
@@cnt:    loop   @@cpn
          jmp    short  @@dtz

@@de0:    mov    ah, seArg1     ;  ᨭ⠪᪮  訡
          cmp    al, 20h        ; ' '
          je     @@cnt
          cmp    al, 9h         ; tab
          je     @@cnt
          cmp    al, 2Dh        ; '-'
          je     @@cnt
          cmp    [Command], 4
          jne    @@dtm
          ;   CCITT
          and    al, 0DFh
          cmp    al, 41h        ; 'A'
          jb     @@era
          cmp    al, 45h        ; 'E'
          ja     @@era
          sub    al, 37h
          jmp    short @@wri

@@dtm:    ;   DTMF
          cmp    al, 2Ah        ; '*'
          jne    @@de2
          mov    al, 14
          jmp    short  @@wri

@@de2:    cmp    al, 23h        ; '#'
          jne    @@de3
          mov    al, 15
          jmp    short  @@wri

@@de3:    and    al, 0DFh
          cmp    al, 41h        ; 'A'
          jb     @@era
          cmp    al, 44h        ; 'D'
          ja     @@era
          sub    al, 37h
          jmp    short  @@wri
@@era:    call   ErrorText
          stc
          ret

@@dtz:    mov    ah, seArg0     ;   
          or     dx, dx
          jz     @@era
          cmp    dx, 20
          mov    ah, seArg2     ; ᫨誮    
          ja     @@era
          mov    al, -1
          stosb                 ; 塞 -1 :  ப
          ; 뢮 ଠ
          mov    al, 7
          mov    dx, offset CCITTdial
          cmp    [Command], 4
          je     @@cci
          mov    dx, offset DTMFdial
@@cci:    call   PrintString
          mov    al, 15
          mov    dx, offset NomerIn
          call   PrintString

          mov    dx, [DelayAon] ; ⥫쭮  ।  
          mov    bp, [PauseDig] ; 㧠    ࠬ
          or     dx, dx
          jnz    @@dl0
          mov    dx, 50
@@dl0:    or     bp, bp
          jnz    @@dl20
          mov    bp, 50
@@dl20:   cmp    [PlayLoop], 0
          jnz    @@lp0
          inc    [PlayLoop]
@@lp0:    mov    bx, offset DTMF_Freq
          cmp    [Command], 4
          jne    @@dt3
          mov    bx, offset CCITT_Freq
@@dt3:    mov    si, offset NomerOut
          call   Make2Tone
          mov    ah, seArg3
          jcxz   @@era       ; 訡. ९ 
          ret
ENDP
;--------------------------------------------------------------------------
PROC      MakeDisaon          ; ନ஢ ࢠ쭮 

          call   CalcLeng     ; 室  ப 㬥⮢
          jcxz   @@erb        ; 訡: ப 
          mov    si, di
          mov    di, offset NomerOut
          ; 横 ஢ 
          xor    dx, dx
          dec    si
          mov    bl, [ds:si]   ; ࠭塞  BL ⥣
          mov    al, 12
          stosb                ; "砫 ।"
          mov    ah, -1
          inc    cx            ; +1 .. ⥣ 2 ࠧ
@@nx:     mov    al, bl
          cmp    cx, 1
          je     @@zr
          std
          lodsb                ; ६    ப 
@@zr:     cld
          cmp    al, '0'
          jb     @@era         ; ஢ઠ ࠢ쭮
          cmp    al, '9'       ;                㬥⮢
          ja     @@era
          ;  室
          inc    dx            ; +1  稪   
          cmp    al, ah
          mov    ah, al
          jne    @@nc
          ; 
          mov    ah, 13
          mov    [es:di-1], ah ; 塞 ࠭ ᠭ   
          mov    ah, -1
@@nc:     sub    al, 30h
          stosb                ; 襬   室 ப
          jmp    short  @@cn

@@era:    cmp    al, 20h       ; 㥬
          je     @@cn          ;      ஡
          cmp    al, 9h        ;          ⠡
          je     @@cn          ;             ࠧ⥫
          cmp    al, '-'
          je     @@cn
          ; 訡: ⨬ ᨬ  
          mov    ah, seArg1
@@erb:    call   ErrorText
          stc
          ret

@@cn:     loop   @@nx
          mov    ah, seArg0
          mov    al, 12         ; 塞 " ।"
          stosb
          mov    al, -1         ; 塞  ப
          stosb
          or     dx, dx
          jz     @@erb           ; 訡.   .
          mov    ah, seArg2
          cmp    dx, 21
          ja     @@erb           ; 訡.     20
          ; 뢮  ଠ
          mov    al, 7
          mov    dx, offset CodNumber
          call   PrintString
          mov    dx, offset NomerIn
          mov    al, 15
          call   PrintString

          mov    bx, offset CCITT_Freq
          mov    si, offset NomerOut
          mov    bp, [PauseDig]  ; 㧠    ࠬ
          mov    dx, [DelayAon]  ; ⥫쭮  ।  
          or     dx, dx
          jnz    @@dl0
          mov    dx, 48
@@dl0:    cmp    [PlayLoop], 0
          jnz    @@lp0
          mov    [PlayLoop], 3
@@lp0:    call   Make2Tone
          mov    ah, seArg3
          jcxz   @@erb
          ret
          endp
;--------------------------------------------------------------------------
          p386
;--------------------------------------------------------------------------
PROC      InitFpu                ; ஢ઠ  ᮯ
          finit                  ;  ᫮ ﭨ
          mov    [Var3], 5A5Ah
          fnstsw [Var3]          ; ࠭  ஢ઠ ᫮ ﭨ
          mov    ax, [Var3]
          or     al, al
          jz     @@f0
          ;  ᮯ
          stc
          ret

@@f0:     fnstcw [Var3]
          mov    ax, [Var3]
          and    ax, 103Fh
          cmp    ax, 3Fh
          je     @@f1
          ;  ᮯ
          stc
          ret
@@f1:
          ; ஢ઠ ᮯ஢ 80287, 80387  80386
          fld1
          fldz
          fdiv                   ;  8087  80287
          fld    st              ; ନ஢ ⥫쭮
                                 ; ᪮筮
          fchs
          fcompp
          fstsw  [Var3]
          mov    ax, [Var3]      ;  80387   ⥫쭠
          sahf                   ;  ⥫쭠 ᪮筮
          jnz    @@f2            ; 㤥 ࠧ.
          ;  387 -  .
          stc
          ret

@@f2:     ; ᮯ 387   
          fldpi                  ; 祭 ᫠ pi
          fld    [X360]          ; 㧪 ᫠ 180.0
          fdiv                   ;    pi
          fstp   [X360]          ; . .  ࠤ-ࠤ
          clc
          ret
ENDP
;--------------------------------------------------------------------------
PROC      MakeSound                 ; AX=, 
                                    ; BL=  (1,2...)
                                    ; DX=⥫쭮  
                                    ; CX=᪮쪮     
          push   dx bx cx
          ;  ⥫쭮
          mov    [word Var0+0], ax
          mov    [word Var0+2], 1000
          fild   [word Var0+0]
          fild   [word Var0+2]
          fdiv
          mov    [word Var0+0], dx
          fild   [word Var0+0]
          fmul
          mov    [word Var1+0], 360
          fild   [word Var1+0]
          fmul
          fstp   [Var2]
          ;  饭 㣫
          mov    cx, 360
          mul    cx                 ; * 360
          mov    [word Var0+0], ax
          mov    [word Var0+2], dx
          xor    ax, ax
          mov    al, [SbFreq]       ;  ⨧樨, 
          cmp    al, 11
          jne    @@sa
          mov    ax, 11111
          jmp    short @@sd
@@sa:     cmp    al, 22
          jne    @@sb
          mov    ax, 22222
          jmp    short @@sd
@@sb:     cmp    al, 44
          jne    @@sd
          mov    ax, 45454
@@sd:     mov    [word Var1+0], ax
          mov    [word Var1+2], 0
          fild   [Var0]             ; (Freq*360)
          fild   [Var1]             ; (SbFreq*1000)
          fdiv                      ; (Freq*360)/(SbFreq*100)
          fstp   [Var1]             ; ࠭ १
          pop    cx
          jcxz   @@br
          mov    bh, bl
          cmp    bl, 1
          jne    @@lp
          mov    ax, [word Var1+0]  ;  [Var1] = [Var0] 
          mov    dx, [word Var1+2]  ; 㥬 ⮫쪮 
          mov    [word Var0+0], ax  ;                   ମ
          mov    [word Var0+2], dx

@@lp:     ; ஢ઠ  
          fld    [Var0]             ; ⥪. 祭 㣫
          fcomp  [Var2]             ; ࠢ  
          fstsw  ax                 ; ॣ 䫠 襬  AX
          and    ah, 45h            ; 뤥塞 ⮫쪮 䫠 C0, C2, C3
          cmp    ah, 80h            ; ࠢ?
          je     @@br               ;  - 
          or     ah, ah             ; ?
          jz     @@br               ;  - 
          ;  Y
          fld    [X360]             ; . ॢ ࠤ-ࠤ
          fmul   [Var0]             ; * ⥪. 祭 㣫
          fsin                      ;  ᨭ
          fild   [Amp]              ; 㧨 
          fmul                      ; ᨭ * 
          fistp  [Var3]             ; ࠭  
          ;
          fld    [Var0]             ; ⥪.祭 㣫
          fadd   [Var1]             ; + 饭
          fstp   [Var0]             ; ࠭
          mov    ax, 128
          sub    ax, [Var3]         ; Y = 128 - [Var2]
          dec    bl
          jnz    @@sk
          mov    bl, bh             ;  ମ
          mov    [es:di], al        ; 襬  
@@sk:     inc    di                 ;  ᫥. 
          loop   @@lp               ;    
@@br:     pop    bx dx
          ret
ENDP
;--------------------------------------------------------------------------
          DATASEG
Ten                dw     10        ; ⠭    10
X360               dd     180.0     ;   ࠤ - ࠤ
Amp                dw     120       ; ନ஢ ᨭᮨ


;   Ŀ
;   DTMF 1209  1336  1477  1633 
;   Ĵ
;   697   1     2     3     A   
;   Ĵ
;   770   4     5     6     B   
;   Ĵ
;   852   7     8     9     C   
;   Ĵ
;   941   *     0     #     D   
;   

LABEL              DTMF_Freq    Byte
                   dw    941    ; 0
                   dw    1336
                   dw    697    ; 1
                   dw    1209
                   dw    697    ; 2
                   dw    1336
                   dw    697    ; 3
                   dw    1477
                   dw    770    ; 4
                   dw    1209
                   dw    770    ; 5
                   dw    1336
                   dw    770    ; 6
                   dw    1477
                   dw    852    ; 7
                   dw    1209
                   dw    852    ; 8
                   dw    1336
                   dw    852    ; 9
                   dw    1477
                   dw    697    ; A
                   dw    1633
                   dw    770    ; B
                   dw    1633
                   dw    852    ; C
                   dw    1633
                   dw    941    ; D
                   dw    1633
                   dw    941    ; *
                   dw    1209
                   dw    941    ; #
                   dw    1477

;   Ŀ
;      祭   樨   ,   
;   Ĵ
;    1  1             f0 f1              700,900      
;   Ĵ
;    2  2             f0 f2              700,1100     
;   Ĵ
;    3  3             f1 f2              900,1100     
;   Ĵ
;    4  4             f0 f4              700,1300     
;   Ĵ
;    5  5             f1 f4              900,1300     
;   Ĵ
;    6  6             f2 f4              1100,1300    
;   Ĵ
;    7  7             f0 f7              700,1500     
;   Ĵ
;    8  8             f1 f7              900,1500     
;   Ĵ
;    9  9             f2 f7              1100,1500    
;   Ĵ
;    10 0             f1 f7              1300,1500    
;   Ĵ
;    11 A             f0 f11             700,1700     
;   Ĵ
;    12 B             f1 f11             900,1700     
;   Ĵ
;    13 C             f2 f11             1100,1700    
;   Ĵ
;    14 D             f1 f11             1300,1700    
;   Ĵ
;    15 E             f7 f11             1500,1700    
;   


LABEL              CCITT_Freq    Byte
                   dw    1300    ; 0
                   dw    1500
                   dw    700     ; 1
                   dw    900
                   dw    700     ; 2
                   dw    1100
                   dw    900     ; 3
                   dw    1100
                   dw    700     ; 4
                   dw    1300
                   dw    900     ; 5
                   dw    1300
                   dw    1100    ; 6
                   dw    1300
                   dw    700     ; 7
                   dw    1500
                   dw    900     ; 8
                   dw    1500
                   dw    1100    ; 9
                   dw    1500
                   dw    700     ; A
                   dw    1700
                   dw    900     ; B
                   dw    1700
                   dw    1100    ; C     (砫)
                   dw    1700
                   dw    1300    ; D     ()
                   dw    1700
                   dw    1500    ; E     ()
                   dw    1700


PressKey           db     '<஡>-㧠, <ESC>-室, <Ctrl-Break>-.',0Dh,0Ah,0
Repeat             db     ': ',0
PauseMsg           db     ' (* 㧠 *)',0
StopMsg            db     ' (* ⮯ *)',0
CodNumber          db     '஢ : ',0
DTMFdial           db     '  : ',0
CCITTdial          db     'ନ஢  CCITT: ', 0
FreqFreq           db     'ନ஢ ᨣ: ',0
FreqDelay          db     '⥫쭮        : ',0
FreqPause          db     '㧠               : ',0
Herz               db     ' ',0
Msc                db     ' ',0
Done               db     ' Ok.',0

CRLF               db     0Dh,0Ah
SpaceChar          db     20h,0
HelpDisaon         db     'ᠫ  -ଠ OH.  ',0
Vers               db     ' 1.2',0Dh,0Ah,0
Copyright          db     'Copyright Vladislav Ivanov 2:5069/16@fidonet. Astrakhan, Russia, 1999.',0Dh,0Ah,0
HelpText           db     '   : DISAON -<> <[-]> | <ᨣ> [ᨣ] [/樨]',0Dh,0Ah
                   db     '  : -a     :  ࢠ쭮  AOH.',0Dh,0Ah
                   db     '           -d     : DTMF ( 2  8).',0Dh,0Ah
                   db     '           -c     :  ⠭ CCITT ( 2  6).',0Dh,0Ah
                   db     '           -f     :    権.',0Dh,0Ah
                   db     '           -h, -? : ⪠ ࠢ (  ࠬ஢).',0Dh,0Ah
                   db     'H-: H ⥫䮭  ⥣  (ᨬ 20 )',0Dh,0Ah
                   db     '   : _1,⥫쭮[,㧠] _2,⥫쭮[,㧠]',0Dh,0Ah
                   db     '           _1+_2+_n,⥫쭮[,㧠] ... ',0Dh,0Ah
                   db     '   樨: /l=xx  : ᫮ ७ (1...65535)           Ŀ',0Dh,0Ah
                   db     '           /v=xx  : ஢ 室 (1...15)                  ᨣ',0Dh,0Ah
                   db     '           /t=xx  : ६   । 1  (9...99 ) ',0Dh,0Ah
                   db     '           /s=xx  : 㧠    ࠬ (0...99 )   ',0Dh,0Ah
                   db     '           /a=xxx :   -뢮 (200-290 hex) Ŀ',0Dh,0Ah
                   db     '           /q=x   : H 뢠 (5,7,10)                㪮 ',0Dh,0Ah
                   db     '           /d=xx  :  ⨧樨 (11,22,44 ) ',0Dh,0Ah
                   db     '           /p     :    । ந.',0Dh,0Ah
                   db     '           /w     :  a ᫥  横 ந.',0Dh,0Ah
                   db     '           /b     : 뢮  ࠭ ।⢠  (/).',0Dh,0Ah
                   db     '           /i     : १ࢨ஢.',0

CtrlBreak          db     ' (* Hଠ쭮 襭 *)',0
SbErr              db     '㪮    訡.',0
CmdErr             db     '⨬ .',0
ArgErr0            db     'H  㬥.',0
ArgErr1            db     '⠪᪠ 訡  .',0
ArgErr2            db     '  ᫨誮  .',0
ArgErr3            db     '९ .',0
ArgErr4            db     'Hࠢ ࠬ ᨣ.',0
OptErr             db     'H୮  .',0
FpuErr             db     ' ᮯ.',0
MemErr             db     'H筮 .',0

          UDATASEG
; ६  ࠡ 㪮 
SbPort             dw     ?     ; .   /
SBuferSize         dw     ?     ; ࠧ  SB
SbFreq             db     ?     ;  . SB 
SbIrq              db     ?     ; IRQ
SbBusy             db     ?     ; ⠭ 1 ᫨  ந 㪠
SBufer             dw     ?     ; ᥣ SB 
SbInfo             db     ?     ; 뢮 ଠ  
; .  ⮢ DSP
SbWriteData        dw     ?
SbReadData         dw     ?
SbReset            dw     ?
SbWriteStatus      dw     ?
SbDataAvail        dw     ?
SbMixerAddr        dw     ?
SbMixerData        dw     ?
;  ࠡ稪 SB irq  DMA
szb                dw     ?
size1              dw     ?
DMAofs1            dw     ?
DMApge1            db     ?
DMAok1             db     ?
DMApge             db     ?
DMAoffs            dw     ?
; ਣ.  ஢ irq 5, 7, 10  ⮢ 21h, A1h
old5               dd     ?
old7               dd     ?
old10              dd     ?
old21              db     ?
oldA1              db     ?
; ६  .  饩 窮
Var0               dd     ?
Var1               dd     ?
Var2               dd     ?
Var3               dw     ?
;  ନ஢   ந 
DosExitCode        db     ?           ; DOS errorlevel
BreakFlag          db     ?           ;  Ctrl-Break
SaveBreak          db     ?           ; .  Ctrl-Break
OldInt1B           dd     ?           ; .  ࠡ稪 Ctrl-Break
DosPrint           db     ?           ; 뢮  ࠭ १ DOS
Command            db     ?           ;  ᪠
AutoPause          db     ?           ; 㧠 ᫥  横 ந
WaitKey            db     ?           ;   । ந
Cancel             db     ?           ;  ESC  ந
Cursor             dw     ?           ; . 
SoundSize          dw     ?           ; ᪮쪮 ⮢   ந
PlayLoop           dw     ?           ; ᫮ ७
DelayAon           dw     ?           ; ⥫쭮 ந.  
PauseDig           dw     ?           ; 㧠   ࠬ
Volume             db     ?           ; 室 ஢ ᨣ
NomerIn            db     100 dup (?); 㬥   ப
NomerIn_L          = $
NomerOut           db     100 dup (?) ; ஢ 
DigitBufer         db     10  dup (?) ;  ८ࠧ Bin <-> ASCII
DigitBufer_L       = $
LastByte           = $

          STACK 100h

          END    start

